// P11_MaTempera
// Lecture de la température interne du mikon
// OEN 201703 V1.0
///////////////////

void setup()
{
  Serial.begin(9600);
  Serial.println(F("Temperature interne du micro-controleur !"));
}

void loop()
{
  unsigned int wLecture;
  double temp;
  
  // Configure ref interne et le mux.
  ADMUX = (_BV(REFS1) | _BV(REFS0) | _BV(MUX3));
  ADCSRA |= _BV(ADEN);  // Active le convertisseur A/N
  delay(20);            // Petite pause pour stabiliser.

  ADCSRA |= _BV(ADSC);  // Lance la conversion...
  // ...et attend qu'elle soit finie
  while (bit_is_set(ADCSRA,ADSC)) ;

  // Recupere les deux octets.
  wLecture = ADCW; // Registre sur 16 bits, un mot (WORD)

  // Convertit de kelvin en Celsius (approximatif).
  temp = (wLecture - 330) / 1.22;

  // On affiche dans le Moniteur.
  Serial.print(temp, 2);
  Serial.println(" degres Celsius");
  delay(1500);
}

