/* ARDUIPROG_KIDZ
 *  CH07B_DevinumLCD
 *  OEN170407
*/

#include <LiquidCrystal.h>           // AJOUT
LiquidCrystal lcd(8, 9, 4, 5, 6, 7); // AJOUT
// PROBLEME1: BROCHE 6 POUR LCD DONC REPLACER yLed8 EN 3
// PROBLEME2: BROCHE 10 POUR RETROECLAIRAGE DONC REPLACER yLed2 EN 3

int iPause = 600;   // REGLABLE AVEC BOUTONS GAUCHE ET DROITE
#define PEU    50   // Pour l'animation d'attente
#define LUMIN 200
const byte yLed1 = 13;           // SANS PWM AU LIEU DE 11
const byte yLed2 = 12;           // SANS PWM AU LIEU DE 10
const byte yLed4 = 11;           // AU LIEU DE 9
const byte yLed8 = 3;            // AU LIEU DE 6
const byte RETROECL = 10;        // AJOUT

#define btnNONE   0
#define btnUP     1
#define btnRIGHT  2
#define btnDOWN   3
#define btnLEFT   4
#define btnSELECT 5

byte ayTablo[10];   // Le fameux tableau!
byte yPrecedent = 0;                    // AJOUT
int lcd_key     = 0;                    // AJOUT
int adc_key_in  = 0;                    // AJOUT
int reponse = 0;

void setup() {
  pinMode(yLed1, OUTPUT);
  pinMode(yLed2, OUTPUT);
  pinMode(yLed4, OUTPUT);
  pinMode(yLed8, OUTPUT);
  Serial.begin(9600);
  Serial.println("*** Bienvenue chez DEVINUM LCD ***");
  lcd.begin(16, 2);            // AJOUT
  lcd.println("*** DEVINUM *** ");
  analogWrite(RETROECL, 50);
}

void loop() {
  for (byte i = 0; i < 10; i++) {
    ayTablo[i] = tirerAuSort(yPrecedent);  // MODIF
    yPrecedent = ayTablo[i];               // AJOUT
    Serial.println(" ");
    Serial.print(ayTablo[i]);
    afficherBin(ayTablo[i]);
    toutEteindre();
  }
  afficherReponses();
  if (attendreSaisie() != btnSELECT) attendreSaisie();
  afficherBin(15);
  delay(1000);
  afficherBin(0);
  delay(2000);
}

byte tirerAuSort(byte prec) { // AJOUT
  byte bNbr;
  bNbr = random(1, 15);
  while (bNbr == prec) bNbr = random(1, 15);
  return(bNbr);  
}

void afficherBin(byte bNum) {
  if (bNum == 0) return;
  Serial.print("\t Binaire ");
///////////////////////////////////////////////////////////
// ERRATA DANS LE LIVRE: IL FAUT AFFICHER LE MSB EN PREMIER
  if (bitRead(bNum, 3)) agir(yLed8, LUMIN);
  else agir(yLed8, 0);
  if (bitRead(bNum, 2)) agir(yLed4, LUMIN);
  else agir(yLed4, 0);
  if (bitRead(bNum, 1)) agirDig(yLed2, LUMIN);
  else agirDig(yLed2, 0);
  if (bitRead(bNum, 0)) agirDig(yLed1, LUMIN);
  else agirDig(yLed1, 0);
  delay(iPause*3);
}

void agir(byte bBroche, byte bValeur) {
  analogWrite(bBroche, bValeur);
  Serial.print(boolean(bValeur));
}
// POUR BROCHE SANS PWM
void agirDig(byte bBroche, byte bValeur) {
  digitalWrite(bBroche, bValeur);
  Serial.print(boolean(bValeur));
}
void toutEteindre() {
  analogWrite(yLed8, 0);
  analogWrite(yLed4, 0);
  digitalWrite(yLed2, 0);
  digitalWrite(yLed1, 0);
  delay(iPause*3);
}

void afficherReponses() {
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.println("Il fallait lire ");
  Serial.println();
  Serial.print("Il fallait lire : ");
  delay(iPause*10);
  lcd.clear();
  lcd.setCursor(0,0);
  for (byte i = 0; i < 5; i++) {
    if (ayTablo[i] < 10)     lcd.print(" ");
    lcd.print(ayTablo[i]);
    lcd.print(" ");
    Serial.print(ayTablo[i]);
    Serial.print(" ");
  }
  lcd.setCursor(0,1);
  for (byte i = 5; i < 10; i++) {
    if (ayTablo[i] < 10)     lcd.print(" ");
    lcd.print(ayTablo[i]);
    lcd.print(" ");
    Serial.print(ayTablo[i]);
    Serial.print(" ");
  }
  Serial.println();
  delay(iPause*20);
}

int attendreSaisie(){
//  lcd.println("Bouton = rejouer");
  do {
    reponse = lireBoutons();
    animerAttente();
  }
  while ( !reponse );
  if (reponse == btnRIGHT) iPause-=100;
  if (reponse == btnLEFT) iPause+=100;
  if (reponse == btnSELECT) return(reponse);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.println("*** DEVINUM ***");
}

// AJOUT
int lireBoutons(){ 
  adc_key_in = analogRead(0);
  if (adc_key_in > 1000) return btnNONE; 
  if (adc_key_in < 50)   return btnRIGHT;  
  if (adc_key_in < 250)  return btnUP; 
  if (adc_key_in < 450)  return btnDOWN; 
  if (adc_key_in < 650)  return btnLEFT; 
  if (adc_key_in < 850)  return btnSELECT;  
  return btnNONE; 
}

void animerAttente() {
  analogWrite(yLed1, 200);
  delay(PEU);
  analogWrite(yLed1, 0);
  delay(PEU*10);
}
