// Main2Passe2 (Ajout evaluer())
// OEN 181113

#define brEnvoiPulse 12       // Broche TNG  du capteur
#define brRetourEcho 13       // Broche ECHO du capteur
#define LIMITE  40
#define LGR      8            // V2
#define TOP   1000            // V2
#define brLEDb    3       // LED bleue V3
#define brLEDj    9       // LED jaune V3
#define brLEDv   10       // LED verte V3
#define brLEDr   11       // LED rouge V3
#define VEILLE    0       // V3
#define REVEIL    1       // V3
#define VICTOIRE  4       // V4
#define ECHEC     8       // V4

float fDistance;              
char tcCode[LGR+1]   = "00000000";  // V2
char tcSecret[LGR+1] = "01010101";  // V3
char cEtat;                         // V3

void setup() 
{ 
  Serial.begin(9600); 
  pinMode(brEnvoiPulse, OUTPUT); 
  pinMode(brRetourEcho, INPUT); 
  pinMode(brLEDb, OUTPUT);  // V3
  pinMode(brLEDj, OUTPUT);  // V3
  pinMode(brLEDv, OUTPUT);  // V3
  pinMode(brLEDr, OUTPUT);  // V3
  cEtat = VEILLE;           // V3
  Serial.println("*** Projet CH13B_Main2Passe ***");  // V4
}

void loop()      // Modif en V4
{ 
  switch (cEtat) {
    case VEILLE:
      informer(VEILLE);
      if (testerPresence()) { cEtat = REVEIL; }
      else delay(TOP*3);
      break;
    case REVEIL:
      informer(REVEIL);
      collecter();
      Serial.println(tcSecret);
      Serial.println(tcCode);
      evaluer();               // Ajout V4
      cEtat = VEILLE;
      break;
  }
}

boolean palper() {
  digitalWrite(brEnvoiPulse, LOW);
  delayMicroseconds(2); 
  digitalWrite(brEnvoiPulse, HIGH); 
  delayMicroseconds(10); 
  digitalWrite(brEnvoiPulse, LOW);
  fDistance = pulseIn(brRetourEcho, HIGH); 
  fDistance = fDistance / (29*2); 
  Serial.println(fDistance);
  if (fDistance < LIMITE) return(true); 
  else return(false);
}

boolean collecter() {          // Modif V3
  for (int i = 0; i < LGR; i++) {
    digitalWrite(brLEDv, HIGH);
    delay(TOP/2);
    if (palper()) { tcCode[i] = '1'; }
    else {          tcCode[i] = '0'; }
    digitalWrite(brLEDv, LOW);
    delay(TOP/2);
  }
  return(true);
}

boolean testerPresence() {     // V3
  Serial.print("Test de presence : ");
  return(palper());
}

void informer(int mode) {     // V3
  switch (cEtat) {
    case VEILLE : 
      Serial.println("En veille... ");
      for (int k = 0; k < 255; k++) {
        analogWrite(brLEDb, k);
        delay(TOP/200); 
      }
      for (int k = 255; k > 0; k--) {
        analogWrite(brLEDb, k);
        delay(TOP/200); 
      }
      digitalWrite(brLEDb, LOW);
      break;
    case REVEIL : 
      Serial.println("En avant pour la gestuelle magique... ");
      for (int k = 0; k < 5; k++) {
        digitalWrite(brLEDj, HIGH);
        delay(TOP/2);
        digitalWrite(brLEDj, LOW);
        delay(TOP/2);
      }
      break;
    case VICTOIRE :               // Cas V4
      for (int k = 0; k < 10; k++) {
        digitalWrite(brLEDv, HIGH);
        delay(TOP/4);
        digitalWrite(brLEDv, LOW);
        delay(TOP/8);
      }
      break;
    case ECHEC :                 // Cas V4
      for (int k = 0; k < 10; k++) {
        digitalWrite(brLEDr, HIGH);
        delay(TOP/4);
        digitalWrite(brLEDr, LOW);
        delay(TOP/8);
      }
      break;
     default: break;
  }
}

boolean evaluer() {                // Ajout V4
  for (int i = 0; i<8; i++) {
    if (tcCode[i] != tcSecret[i]) {
      cEtat = ECHEC;
      Serial.println("*** ECHEC ***");
      informer(cEtat);
      return(false);
    }
    else { 
      if (i == 7) {
        cEtat = VICTOIRE;
        Serial.println("*** V I C T O I R E ***");
        informer(cEtat);
      }
    }
  }
  return(true);
}
